#!/bin/bash

program_name=$(basename $0)
who=$(whoami)

if [ "$who"  != "root" ] ; then
	echo "you are not root ! "
	echo "try to use fakeroot before launching $program_name"
	exit
fi

if [ -z $1 ] ; then
        echo "Usage:  $program_name RFS-to-archive "
        exit
fi

if [ -d $1 ] ; then
	tmp_rfscpio=$(mktemp)
	local_dir=$(pwd)
	initrd_default_name="initramfs3-"$(basename $1)".gz"
	echo "By default, initrfs file will be $initrd_default_name proceed ? Y [n]"
                read -s -n 1 resp
                if [ "$resp" == n ] ; then 
                        echo  "please enter initrfs file name"
                        read -r initrd_default_name
                        if [ -z $initrd_default_name ] ; then
                                echo "Error, the name is empty"
				rm $tmp_rfscpio
                                exit
                        fi
                fi
	cd $1
	find . | cpio -o -H newc | gzip  >$tmp_rfscpio
	cd $local_dir
	size_str=$(ls -al $tmp_rfscpio | cut -d " " -f 5)
	if [[ $size_str -gt 3145728 ]] ; then
		echo "Error, image size is too big"
		exit
	fi
	header_file=$(mktemp)
	$local_dir/headermake $size_str $header_file
	cat $header_file $tmp_rfscpio > $initrd_default_name
	rm $header_file
	rm $tmp_rfscpio
	exit
else
	echo $1 is not a valid directory !!
	exit
fi


