#!/bin/bash

program_name=$(basename $0)
who=$(whoami)
if [ "$who"  != "root" ] ; then
	echo "you are not root ! "
	echo "try to use fakeroot before launching $program_name"
	exit
fi

local_dir=$(pwd)

if [ -z $1 ] ; then
	echo "Usage:  $program_name file_to_extract "
	exit
fi

if [ -e $1 ] ; then
	header=$(head -c4 $1)
	if [ "$header" == "KAGZ" ] ; then
		echo "find correct header KAGZ in $1 file, program start..."
		tmp_gzfile=$(mktemp)
		rfs_default_name="RFS-"$(echo $(basename $tmp_gzfile) | sed 's/tmp.//')
		tail -c+9 $1 > $tmp_gzfile
		mv $tmp_gzfile $tmp_gzfile".gz"
		gunzip $tmp_gzfile".gz"
		echo "By default, RFS folder will be $rfs_default_name proceed ? Y [n]"
		read -s -n 1 resp
		if [ "$resp" == n ] ; then 
			echo  "please enter the RFS folder name"
			read -r rfs_default_name
			if [ -z $rfs_default_name ] ; then
				echo "Error, the name is empty"
				rm $tmp_gzfile
				exit
			fi
		fi
		rfs_path=$local_dir"/"$rfs_default_name
		mkdir $rfs_path
		cd $rfs_path
		cpio -i < $tmp_gzfile
		cd $local_dir
		rm $tmp_gzfile
		echo "Job done"

	else
		echo "Error, $1 doesn't seem to be a valid initramfs archive"
	fi
else
	echo "Error, don't find $1 file !!"
	exit
fi
